﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace DatabazeParkourovychSpotu
{
    /// <summary>
    /// Interaction logic for CustomMessageBox.xaml
    /// </summary>
    public partial class CustomMessageBox : Window
    {
        static CustomMessageBox MsgBox;
        static bool result = false;

        public CustomMessageBox()
        {
            InitializeComponent();
        }

        // metoda Show pro CustomMessageBox se 4 parametry -> text zprávy, záhlaví formuláře, 2 buttony
        public static bool Show(string text, string caption, string anoButton, string neButton)
        {
            MsgBox = new CustomMessageBox();
            MsgBox.zpravaTextBlock.Text = text;
            MsgBox.anoButton.Content = anoButton;
            MsgBox.neButton.Content = neButton;
            MsgBox.Title = caption;
            MsgBox.ShowDialog();
            return result;
        }

        // metoda Show pro CustomMessageBox se 2 parametry -> text zprávy, záhlaví formuláře
        public static bool Show(string text, string caption)
        {
            MsgBox = new CustomMessageBox();
            MsgBox.zpravaTextBlock.Text = text;
            MsgBox.Title = caption;
            MsgBox.ShowDialog();
            return result;
        }

        // metoda Show pro CustomMessageBox s 1 parametrem -> text zprávy
        public static bool Show(string text)
        {
            MsgBox = new CustomMessageBox();
            MsgBox.zpravaTextBlock.Text = text;
            MsgBox.Title = "";
            MsgBox.ShowDialog();
            return result;
        }


        // po kliknutí na button vlevo (button pro potvrzení akce) vrátí true a zavře MessageBox
        private void anoButton_Click(object sender, RoutedEventArgs e)
        {
            result = true;
            MsgBox.Close();
        }

        // po kliknutí na button vpravo (button pro zrušení akce) vrátí false a zavře MessageBox
        private void neButton_Click(object sender, RoutedEventArgs e)
        {
            result = false;
            MsgBox.Close();
        }

        // po kliknutí na button vpravo (button OK) vrátí true a zavře MessageBox
        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            result = true;
            MsgBox.Close();

        }

        // po načtení okna
        // když levý button (anoButton) má vyplněný text, zobrazí se na formluláři 2 buttony - buttony pro Yes a No, jinak se zobrazí pouze button OK
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {         
                if (this.anoButton.Content.ToString().Length > 0)
                {
                    OKButton.Visibility = Visibility.Collapsed;
                    anoButton.Visibility = Visibility.Visible;
                    neButton.Visibility = Visibility.Visible;
                    neButton.Focus();
                }
                else
                {
                    OKButton.Visibility = Visibility.Visible;
                    anoButton.Visibility = Visibility.Collapsed;
                    neButton.Visibility = Visibility.Collapsed;
                    OKButton.Focus();
                }
            }
    }
}
