﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace DatabazeParkourovychSpotu
{
    public static class Extensions
    {
        public static string CreateUrl(this string str)
        {

            str = str.Normalize(NormalizationForm.FormD);
            char[] filtrovano = str.Where(c => char.GetUnicodeCategory(c) != UnicodeCategory.NonSpacingMark).ToArray();
            str = new String(filtrovano);
            str = str.Replace("(", "").Replace(")", "").Replace(" - ", "-").Replace(" / ", "-").Replace("/", "-").Replace(".", "").Replace("?", "").Replace(" ", "-").Replace("---", "-").Replace("--", "-").ToLower().Replace("(", "").Replace(")", "").Replace(" - ", "-").Replace(" / ", "-").Replace("/", "-").Replace(".", "").Replace("?", "").Replace(" ", "-").Replace("---", "-").Replace("--", "-");
            str = str.ToLower();
            return str;
        }

        public static IEnumerable<Visual> GetChildren(this Visual parent, bool recurse = true)
        {
            if (parent != null) // když prvek, ze kterého chceme získat potomky není null
            {
                int pocetPotomku = VisualTreeHelper.GetChildrenCount(parent); // získá počet potomků
                for (int i = 0; i < pocetPotomku; i++)
                {
                    // získá potomka podle indexu a rodiče
                    var potomek = VisualTreeHelper.GetChild(parent, i) as Visual;

                    if (potomek != null) // když potomek, není null
                    {
                        yield return potomek; // meotda mi vrátí potomka, yield - vrátí objekt typu IEnumerable

                        if (recurse) // když máme zvolenou rekurzi (prochází se potomci potomků)
                        {
                            foreach (var potomekPotomka in potomek.GetChildren(true)) // volá se tato funkce znovu, nyní se prochází potomci potomka
                            {
                                yield return potomekPotomka;
                            }
                        }
                    }
                }
            }
        }

        // zakóduje heslo zadané uživatelem
        public static string HashPassword(this string heslo)
        {
            byte[] asciiBytes = ASCIIEncoding.ASCII.GetBytes(heslo);
            byte[] hashedBytes = MD5CryptoServiceProvider.Create().ComputeHash(asciiBytes);
            heslo = BitConverter.ToString(hashedBytes).Replace("-", "").ToLower();
            asciiBytes = ASCIIEncoding.ASCII.GetBytes(heslo);
            hashedBytes = SHA1CryptoServiceProvider.Create().ComputeHash(asciiBytes);
            heslo = BitConverter.ToString(hashedBytes).Replace("-", "").ToLower();
            return heslo;
        }

        public static void OnLostFocus(this PasswordBox c)
        {
            if (c.Password == "")
            {
                foreach (Visual v in c.GetChildren())
                {
                    if (v is Label)
                    {
                        Label label = (Label)v;
                        if (label.Name == "Label")
                        {
                            label.Visibility = Visibility.Visible;
                        }
                    }
                }
            }
            else
                foreach (Visual v in c.GetChildren())
                {
                    if (v is Label)
                    {
                        Label label = (Label)v;
                        if (label.Name == "Label")
                        {
                            label.Visibility = Visibility.Collapsed;
                        }
                    }
                }
        }
        public static void OnGotFocus(this TextBox c)
        {
            if (c.Text == c.Tag.ToString() && c.Name != "PART_EditableTextBox")
            {
                c.Text = "";
                c.Foreground = Brushes.Black;
            }
        }
        public static void OnLostFocus(this TextBox c)
        {
            if (c.Text == "" && c.Name != "PART_EditableTextBox") c.InitialValue();
        }

        public static void InitialValue(this TextBox c)
        {
            c.Text = c.Tag.ToString();
            c.Foreground = new SolidColorBrush(Color.FromArgb(255, 96, 96, 96));
        }

    }
}
