﻿using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Input;
using System.Windows.Threading;

namespace DatabazeParkourovychSpotu
{
    /// <summary>
    /// Interaction logic for SplashScreen.xaml
    /// </summary>
    public partial class SplashScreen : Window, INotifyPropertyChanged
    {
        private DispatcherTimer _timer = new DispatcherTimer();
        private int _timeout = -1;
        private MainWindow _mainWindow;

        private string _nacitaniText;
        public event PropertyChangedEventHandler PropertyChanged;
        public string NacitaniText
        {
            get { return _nacitaniText; }
            set
            {
                _nacitaniText = value;
                OnPropertyChanged("NacitaniText");
            }
        }
        private void OnPropertyChanged(String info)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(info));
        }


        // v konstruktoru se předá výchozí Window, z kterého se Splash Screen Window otevírá = MainWindow
        // nastaví se timer pro zobrazení načítání
        public SplashScreen(MainWindow mw)
        {
            InitializeComponent();
            _mainWindow = mw;
            NacitaniText = "Načítání aplikace";
            DataContext = this;
            this.Opacity = 1;
            _timer.Interval = TimeSpan.FromMilliseconds(400);
            _timeout = 16;
            _timer.Start();
            _timer.Tick += Timer_Tick;
        }


        // timer pro zobrazení načítání aplikace
        private void Timer_Tick(object sender, EventArgs e)
        {
            if (_timeout > 0) _timeout--;
            if (NacitaniText != "Načítání aplikace")
            {
                if (nacitaniNadpisTextBlockTecky.Text == "...") nacitaniNadpisTextBlockTecky.Text = "";
                else nacitaniNadpisTextBlockTecky.Text += ".";
            }
            if (_mainWindow._splashClose && _timeout == 0)
            {
                _timer.Stop();
                this.Close();
            }
        }

        // po zavření SplashScreenu se zobrazí hlavní Aplikace - zobrazí se hlavní okno, dole na liště se zobrazí ikona - MainWindow
        private void Window_Closed(object sender, EventArgs e)
        {
            _mainWindow.ShowInTaskbar = true;
            _mainWindow.Visibility = Visibility.Visible;
        }

        // povolí při držení levého tlačítka myši táhnout okno
        private void Window_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (Mouse.LeftButton == MouseButtonState.Pressed)
                this.DragMove();
        }
    }
}
